unit mystrings;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LclType,
  Dialogs, StdCtrls, ExtCtrls, StrUtils;

const
  FloatCharSet: set of char = ['.', ',', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9' ];
  FloatChars: set of char = ['+', '-', 'e', '.', ',', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9' ];
  InputFloatChars: set of char = ['+', '-', 'e', ',', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', char(vk_Back), char(vk_Delete) ];
  InputIntChars: set of char = ['+', '-', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', char(vk_Back), char(vk_Delete)];


function TryStr2Float(aStr: string; Out value: extended): boolean;
function Str2Float(aStr: string): extended;
procedure MyIntInput(Sender: TObject; var Key: char);
procedure MyFloatInput(Sender: tObject; var Key: char);
function Int2Str(aInt, nPlaces: integer): string;
function Float2Str(aFloat: extended; nPlaces, nDecimals: integer): string;
procedure ChangeSeparators;
function StrIsFloat(aStr: string): boolean;
procedure Read_1Extended(aStr: string; var f1: extended);
procedure Read_2Extended(aStr: string; var f1, f2: extended);
procedure Read_3Extended(aStr: string; var f1, f2, f3: extended);
procedure Read_2ints(aStr: string; var w1, w2: integer);
procedure Read_3ints(aStr: string; var w1, w2, w3: integer);
function ErstesWort(aStr: string): string;

implementation  

function TryStr2Float(aStr: string; Out value: extended): boolean;
var
  E: integer;
begin
  Val(aStr, Value, E);
  if E <> 0 then Result := false else result := true;;
end;

function Str2Float(aStr: string): extended;
var
  E: integer;
begin
  Val(aStr, Result, E);
  if E <> 0 then Result := 0;
end;

procedure MyIntInput(Sender: TObject; var Key: char);
var
  buf: string;
begin
  if not ( Key in InputIntChars ) then Key := #0;
  if Key = '.' then Key := #0;
  if Sender is tLabeledEdit then
  begin
    if Key = '-' then with Sender as tLabeledEdit do
    begin
      if (PosEx('-', Text) <> 0) or (PosEx('+', Text) <> 0) then
      begin
        buf := Text;
        Delete(buf, 1, 1);
        Text := '-' + buf;
      end;
    end;
    if Key = '+' then with Sender as tLabeledEdit do
    begin
      if (PosEx('-', Text) <> 0) or (PosEx('+', Text) <> 0) then
      begin
        buf := Text;
        Delete(buf, 1, 1);
        Text := buf;
      end;
    end;
  end;
  if Sender is tEdit then
  begin
    if Key = '-' then with Sender as tEdit do
    begin
      if (PosEx('-', Text) <> 0) or (PosEx('+', Text) <> 0) then
      begin
        buf := Text;
        Delete(buf, 1, 1);
        Text := '-' + buf;
      end;
    end;
    if Key = '+' then with Sender as tEdit do
    begin
      if (PosEx('-', Text) <> 0) or (PosEx('+', Text) <> 0) then
      begin
        buf := Text;
        Delete(buf, 1, 1);
        Text := buf;
      end;
    end;
  end;
end;

procedure MyFloatInput(Sender: TObject; var Key: char);
var
  buf: string;
begin
  if not ( Key in InputFloatChars ) then Key := #0;
  if Key = ',' then Key := '.';
  if Sender is tLabeledEdit then
  begin
    if Key = 'e' then with Sender as tLabeledEdit do
    begin
      if PosEx('e', Text) <> 0 then Key := #0;
    end;
    if Key ='.' then with Sender as tLabeledEdit do
    begin
      if PosEx('.', Text) <> 0 then Key := #0;
    end;
    if Key = '-' then with Sender as tLabeledEdit do
    begin
      if (PosEx('-', Text) <> 0) or (PosEx('+', Text) <> 0) then
      begin
        buf := Text;
        Delete(buf, 1, 1);
        Text := '-' + buf;
      end;
    end;
    if Key = '+' then with Sender as tLabeledEdit do
    begin
      if (PosEx('-', Text) <> 0) or (PosEx('+', Text) <> 0) then
      begin
        buf := Text;
        Delete(buf, 1, 1);
        Text := buf;
      end;
    end;
  end;
  if Sender is tEdit then
  begin
    if Key = 'e' then with Sender as tEdit do
    begin
      if PosEx('e', Text) <> 0 then Key := #0;
    end;
    if Key ='.' then with Sender as tEdit do
    begin
      if PosEx('.', Text) <> 0 then Key := #0;
    end;
    if Key = '-' then with Sender as tEdit do
    begin
      if (PosEx('-', Text) <> 0) or (PosEx('+', Text) <> 0) then
      begin
        buf := Text;
        Delete(buf, 1, 1);
        Text := '-' + buf;
      end;
    end;
    if Key = '+' then with Sender as tEdit do
    begin
      if (PosEx('-', Text) <> 0) or (PosEx('+', Text) <> 0) then
      begin
        buf := Text;
        Delete(buf, 1, 1);
        Text := buf;
      end;
    end;
  end;
end;
                 
function Int2Str(aInt, nPlaces: integer): string;
begin
  Str(aInt: nPlaces, Result);
end;

function Float2Str(aFloat: extended; nPlaces, nDecimals: integer): string;
begin
  Str(aFloat: nPlaces: nDecimals, Result);
end;


//procedure MyFloatInput(Key: char);
//begin
//  if not ( Key in InputFloatChars ) then Key := #0;
//  if Key = ',' then Key := '.';
//end;

procedure ChangeSeparators;
var
  buf: char;
begin
  //buf := FormatSettings.DecimalSeparator;
  //FormatSettings.DecimalSeparator := FormatSettings.ThousandSeparator;
  //FormatSettings.ThousandSeparator := buf;
end;

function StrIsFloat(aStr: string): boolean;
var
  i: integer;
begin
  Result := true;
  if length(aStr) = 0 then Result := false;
  for i := 1 to length(aStr) do
  begin
    if not (aStr[i] in FloatChars) then Result := false;
  end;
  if aStr = 'e' then Result := false;
end;

procedure Read_1Extended(aStr: string; var f1: extended);
var
  TextPos: integer;
  w1: string;
begin
  TextPos := 1;
  w1 := '';
  { 1. Wert auslesen: }
  while (TextPos <= length(aStr)) and not (aStr[TextPos] in FloatCharSet) do TextPos := TextPos + 1;
  while (TextPos <= length(aStr)) and (aStr[TextPos] in FloatCharSet) do
  begin
    w1 := w1 + aStr[TextPos];
    TextPos := TextPos + 1;
  end;
  w1 := StringReplace(w1, '.', ',', [rfReplaceAll]);
  if length(w1) = 0 then f1 := 0.0 else f1 := Str2FLoat(w1);
end;

procedure Read_2Extended(aStr: string; var f1, f2: extended);
var
  TextPos: integer;
  w1, w2: string;
begin
  TextPos := 1;
  w1 := '';
  w2 := '';
  { 1. Wert auslesen: }
  while (TextPos <= length(aStr)) and not (aStr[TextPos] in FloatCharSet) do TextPos := TextPos + 1;
  while (TextPos <= length(aStr)) and (aStr[TextPos] in FloatCharSet) do
  begin
    w1 := w1 + aStr[TextPos];
    TextPos := TextPos + 1;
  end;
  { 2. Wert auslesen: }
  while (TextPos <= length(aStr)) and not (aStr[TextPos] in FloatCharSet) do TextPos := TextPos + 1;
  while (TextPos <= length(aStr)) and (aStr[TextPos] in FloatCharSet) do
  begin
    w2 := w2 + aStr[TextPos];
    TextPos := TextPos + 1;
  end;
  w1 := StringReplace(w1, '.', ',', [rfReplaceAll]);
  w2 := StringReplace(w2, '.', ',', [rfReplaceAll]);
  if length(w1) = 0 then f1 := 0.0 else f1 := Str2FLoat(w1);
  if length(w2) = 0 then f2 := 0.0 else f2 := Str2Float(w2);
end;

procedure Read_3Extended(aStr: string; var f1, f2, f3: extended);
var
  TextPos: integer;
  w1, w2, w3: string;
begin
  TextPos := 1;
  w1 := '';
  w2 := '';
  w3 := '';
  { 1. Wert auslesen: }
  while (TextPos <= length(aStr)) and not (aStr[TextPos] in FloatCharSet) do TextPos := TextPos + 1;
  while (TextPos <= length(aStr)) and (aStr[TextPos] in FloatCharSet) do
  begin
    w1 := w1 + aStr[TextPos];
    TextPos := TextPos + 1;
  end;
  { 2. Wert auslesen: }
  while (TextPos <= length(aStr)) and not (aStr[TextPos] in FloatCharSet) do TextPos := TextPos + 1;
  while (TextPos <= length(aStr)) and (aStr[TextPos] in FloatCharSet) do
  begin
    w2 := w2 + aStr[TextPos];
    TextPos := TextPos + 1;
  end;
  { 3. Wert auslesen: }
  while (TextPos <= length(aStr)) and not (aStr[TextPos] in FloatCharSet) do TextPos := TextPos + 1;
  while (TextPos <= length(aStr)) and (aStr[TextPos] in FloatCharSet) do
  begin
    w3 := w3 + aStr[TextPos];
    TextPos := TextPos + 1;
  end;
  w1 := StringReplace(w1, '.', ',', [rfReplaceAll]);
  w2 := StringReplace(w2, '.', ',', [rfReplaceAll]);
  w3 := StringReplace(w3, '.', ',', [rfReplaceAll]);
  if length(w1) = 0 then f1 := 0.0 else f1 := Str2FLoat(w1);
  if length(w2) = 0 then f2 := 0.0 else f2 := Str2Float(w2);
  if length(w3) = 0 then f3 := 0.0 else f3 := Str2Float(w3);
end;

procedure Read_3ints(aStr: string; var w1, w2, w3: integer);
var
  TextPos: integer;
  Wert: String;
begin
  Wert := '';
  { Beginn der ersten Zahl suchen: }
  TextPos := 1;
  while (TextPos <= length(aStr)) and not (aStr[TextPos] in ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '-']) do TextPos := TextPos + 1;
  //while aStr[TextPos] = ' ' do TextPos := TextPos + 1;
  { ertsen Wert auslesen: }
  while (TextPos <= length(aStr)) and (aStr[TextPos] <> ' ') do
  begin
    Wert := Wert + aStr[TextPos];
    TextPos := TextPos + 1;
  end;
  w1 := StrToInt(Wert);
  { zweiten Wert auslesen: }
  while (TextPos <= length(aStr)) and not (aStr[TextPos] in ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '-']) do TextPos := TextPos + 1;
  Wert := '';
  //while aStr[TextPos] = ' ' do TextPos := TextPos + 1;
  while (TextPos <= length(aStr)) and (aStr[TextPos] <> ' ') do
  begin
    Wert := Wert + aStr[TextPos];
    TextPos := TextPos + 1;
  end;
  w2 := StrToInt(Wert);
  { dritten Wert auslesen: }
  Wert := '';
  //while aStr[TextPos] = ' ' do TextPos := TextPos + 1;
  while (TextPos <= length(aStr)) and not (aStr[TextPos] in ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '-']) do TextPos := TextPos + 1;
  while (TextPos <= length(aStr)) and (aStr[TextPos] <> ' ') do
  begin
    Wert := Wert + aStr[TextPos];
    TextPos := TextPos + 1;
  end;
  w3 := StrToInt(Wert);
end;

procedure Read_2ints(aStr: string; var w1, w2: integer);
var
  TextPos: integer;
  Wert: String;
begin
  Wert := '';
  { Beginn der ersten Zahl suchen: }
  TextPos := 1;
  while (TextPos <= length(aStr)) and not (aStr[TextPos] in ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '-']) do TextPos := TextPos + 1;
  //while aStr[TextPos] = ' ' do TextPos := TextPos + 1;
  { ertsen Wert auslesen: }
  while (TextPos <= length(aStr)) and (aStr[TextPos] <> ' ') do
  begin
    Wert := Wert + aStr[TextPos];
    TextPos := TextPos + 1;
  end;
  w1 := StrToInt(Wert);
  { zweiten Wert auslesen: }
  while (TextPos <= length(aStr)) and not (aStr[TextPos] in ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '-']) do TextPos := TextPos + 1;
  Wert := '';
  //while aStr[TextPos] = ' ' do TextPos := TextPos + 1;
  while (TextPos <= length(aStr)) and (aStr[TextPos] <> ' ') do
  begin
    Wert := Wert + aStr[TextPos];
    TextPos := TextPos + 1;
  end;
  w2 := StrToInt(Wert);
end;

function ErstesWort(aStr: string): string;
var
  TextPos: integer;
  TextBuffer: string;
begin
  TextBuffer := '';
  TextPos := 1;
  while (TextPos <= length(aStr)) and (aStr[TextPos] <> ' ') do
  begin
    TextBuffer := TextBuffer + aStr[TextPos];
    //MyInfoForm.InfoMemo.Lines.Add('.');
    TextPos := TextPos + 1;
  end;
  Result := TextBuffer;
end;

end.

